#include <stdio.h>
#include "my-element.h"

int main(int argc, char *argv[])
{
	struct my_element ele1, ele2, ele3, ele4, *tmp_ele;
	struct list_head *list_ele;

	// head setup (version 1)
	LIST_HEAD(my_list_head);
	// head setup (version 2)
	struct list_head another_list_head;
	INIT_LIST_HEAD(&another_list_head);

	ele1.val = 1;
	ele2.val = 2;
	ele3.val = 3;
	ele4.val = 4;

	if (list_empty(&my_list_head))
		printf("my_list is empty !\n");
	else
		printf("my_list isn't empty just yet !\n");

	// we add these in reverse order because list_add
	// adds elements to the start of the list
	list_add(&ele4.list, &my_list_head);
	list_add(&ele3.list, &my_list_head);
	list_add(&ele2.list, &my_list_head);
	list_add(&ele1.list, &my_list_head);

	printf("Traversing my_list (forward motion)\n");
	FOR_EACH(list_ele, &my_list_head) {
		tmp_ele = list_entry(list_ele, struct my_element, list);
		printf("\tFound an element with value %i\n", tmp_ele->val);
	}

	printf("Traversing my_list (reverse motion)\n");
	FOR_EACH_REVERSE(list_ele, &my_list_head) {
		tmp_ele = list_entry(list_ele, struct my_element, list);
		printf("\tFound an element with value %i\n", tmp_ele->val);
	}

	list_del(&ele3.list);
	list_del(&ele1.list);
	list_add_tail(&ele3.list, &my_list_head);

	printf("Traversing a smaller my_list (forward motion)\n");
	FOR_EACH(list_ele, &my_list_head) {
		tmp_ele = list_entry(list_ele, struct my_element, list);
		printf("\tFound an element with value %i\n", tmp_ele->val);
	}

	if (list_empty(&my_list_head))
		printf("my_list is empty !\n");
	else
		printf("my_list isn't empty just yet !\n");

	printf("Moving some elements from my_list to another_list\n");
	list_del(&ele2.list);
	list_add(&ele2.list, &another_list_head);
	list_add_tail(&ele1.list, &another_list_head);
	list_move(&ele4.list, &another_list_head);

	if (list_empty(&another_list_head))
		printf("another_list is empty !\n");
	else
		printf("another_list isn't empty just yet !\n");

	printf("Traversing another_list (forward motion)\n");
	FOR_EACH(list_ele, &another_list_head) {
		tmp_ele = list_entry(list_ele, struct my_element, list);
		printf("\tFound an element with value %i\n", tmp_ele->val);
	}

	return 0;
}
